////	$RCSfile: phonelist.cpp,v $
////	$Date: 2011/09/26 22:50:50 $
////.BlockStart
#include "phonelist.h"

// Only need to initialize the List object embedded inside
// the PhoneList...
//
PhoneList::PhoneList() : head(0)
{
}
////.BlockEnd

////.BlockStart
// Need to free up any memory pointed to by `head'.
// This means walking through the linked list one
// element at a time, and deleting it.  The only
// problem is that once it's been delete'd, we
// can't access it to retrieve the `Next' pointer,
// so we do that first and save it.
//
PhoneList::~PhoneList()
{
    List *next, *tmp = head;

    while (tmp != 0) {
	next = tmp->GetNext();	// Save pointer to the next one,
	delete tmp;		//  then delete the current and
	tmp = next;		//  move to the following one.
    }
}
////.BlockEnd

////.BlockStart
void PhoneList::Add(Record *r)
{
    // Before the following code:
    //   head -> C -> B -> A --|
    //
    List *tmp = new List(r, head);
    //   head -----------------> C -> B -> A --|
    //               tmp --/
    //
    head = tmp;
    //   head --\           /--> C -> B -> A --|
    //           \-- tmp --/
}
////.BlockEnd

////.BlockStart
void PhoneList::Remove(Record *r)
{
    // The code here looks for a record that matches
    // the parameter `r' and then removes it from
    // the linked list.  This function is left as
    // an exercise for the student.
    // ...
}
////.BlockEnd

////.BlockStart
PhoneListIter::PhoneListIter(PhoneList &p)
    : parent(p)
{
    // 0 is a flag that means to reset to the beginning
    // of the list.  We don't actually go to the beginning
    // right now, because the user may create the
    // iterator and then add new items to the PhoneList
    // which go at the beginning of the list and hence
    // the iterator wouldn't return those items.
    //
    current = 0;
}
////.BlockEnd

////.BlockStart
Record *PhoneListIter::Current()
{
    if (!current)
	current = parent.head;
    return current ? current->GetValue() : 0;
}
////.BlockEnd

////.BlockStart
Record *PhoneListIter::Next()
{
    // This updates our state to point to the next
    // element in the list.  A useful side-effect
    // is that the end of the list is marked with
    // a 0, which we interpret to mean start the
    // iteration over again.  Ie, this function
    // will return 0 once, then walk through the
    // list again starting at the beginning.
    //
    if (!current)
	current = parent.head;		// first on list
    else
	current = current->GetNext();	// next on list
    return current ? current->GetValue() : 0;
}
////.BlockEnd

////.BlockStart
void PhoneListIter::Reset()
{
    current = 0;
}
////.BlockEnd
